package alterrs.jbct.deob;

import static org.objectweb.asm.Opcodes.ACC_NATIVE;
import static org.objectweb.asm.Opcodes.ACC_PRIVATE;
import static org.objectweb.asm.Opcodes.ACC_PROTECTED;
import static org.objectweb.asm.Opcodes.ACC_PUBLIC;

import org.objectweb.asm.tree.ClassNode;
import org.objectweb.asm.tree.MethodNode;

import alterrs.jbct.utility.AbstractTransformer;

/**
 * @author Lazaro Brito
 */
public class PrivilegeDeobfuscator extends AbstractTransformer {
	private int count = 0;

	public PrivilegeDeobfuscator() {
		super(true);
	}

	@Override
	public void visitMethod(ClassNode c, MethodNode m) {
		if (m.name.equals("finalize") && ((m.access & ACC_PRIVATE) == 0)
				&& (m.access & ACC_PROTECTED) == 0) {
			m.access |= ACC_PUBLIC;

			count++;
		}
	}
	
	@Override
	public void visitNativeMethod(ClassNode c, MethodNode m) {
		if (c.name.endsWith("IcmpService") && m.name.equals("quit")) {
			m.access = ACC_PUBLIC | ACC_NATIVE;
			
			count++;
		}
	}

	@Override
	public void onFinish() {
		System.out.println(" ^	Repaired " + count + " method privileges!");
	}
}
