package com.method.rscd.cache.store;

import java.io.EOFException;
import java.io.IOException;

/**
 * Created at: Dec 12, 2016 11:39:43 PM
 * 
 * @author Walied-Yassen A.K.A Cody
 */
public class BufferedDiskFile {

	public long nextSeekOffset;
	public DiskFile file;
	public long aLong5842;
	public int anInt5843;
	public byte[] data;
	public long aLong5845;
	public int anInt5846;
	public long offset;
	public long size;
	public long aLong5849;
	public byte[] buffer;

	public BufferedDiskFile(DiskFile diskFile, int bufferSize, int size) throws IOException {
		this.aLong5845 = -1;
		this.aLong5849 = -1;
		this.anInt5846 = 0;
		this.file = diskFile;
		this.size = aLong5842 = diskFile.getSize();
		this.buffer = new byte[bufferSize];
		this.data = new byte[size];
		this.offset = 0L;
	}

	public void write(byte[] data, int off, int len) throws IOException {
		try {
			if (len + this.offset > this.size) {
				this.size = len + this.offset;
			}
			if (-1L != this.aLong5845 && (this.offset < this.aLong5845 || this.offset > this.anInt5846 + this.aLong5845)) {
				flush();
			}
			if (this.aLong5845 != -1L && this.offset + len > this.data.length + this.aLong5845) {
				int i_2_ = (int) (this.data.length - (this.offset - this.aLong5845));
				System.arraycopy(data, off, this.data, (int) (this.offset - this.aLong5845), i_2_);
				this.offset += i_2_;
				off += i_2_;
				len -= i_2_;
				this.anInt5846 = this.data.length;
				flush();
			}
			if (len > this.data.length) {
				if (this.nextSeekOffset != this.offset) {
					this.file.seek(this.offset);
					this.nextSeekOffset = this.offset;
				}
				this.file.write(data, off, len);
				this.nextSeekOffset += len;
				if (this.nextSeekOffset > this.aLong5842) {
					this.aLong5842 = this.nextSeekOffset;
				}
				long l = -1L;
				long l_3_ = -1L;
				if (this.offset >= this.aLong5849 && this.offset < this.anInt5843 + this.aLong5849) {
					l = this.offset;
				} else if (this.aLong5849 >= this.offset && this.aLong5849 < this.offset + len) {
					l = this.aLong5849;
				}
				if (this.offset + len > this.aLong5849 && len + this.offset <= this.anInt5843 + this.aLong5849) {
					l_3_ = len + this.offset;
				} else if (this.aLong5849 + this.anInt5843 > this.offset && this.aLong5849 + this.anInt5843 <= len + this.offset) {
					l_3_ = this.aLong5849 + this.anInt5843;
				}
				if (l > -1L && l_3_ > l) {
					int i_4_ = (int) (l_3_ - l);
					System.arraycopy(data, (int) (off + l - this.offset), this.buffer, (int) (l - this.aLong5849), i_4_);
				}
				this.offset += len;
			} else {
				if (len <= 0)
					return;
				if (-1L == this.aLong5845) {
					this.aLong5845 = this.offset;
				}
				System.arraycopy(data, off, this.data, (int) (this.offset - this.aLong5845), len);
				this.offset += len;
				if (this.offset - this.aLong5845 > this.anInt5846) {
					this.anInt5846 = (int) (this.offset - this.aLong5845);
				}
			}
		} catch (IOException ioexception) {
			this.nextSeekOffset = -1;
			throw ioexception;
		} finally {
			flush();
		}
	}

	public void read(byte[] data, int off, int len) throws IOException {
		try {
			if (len + off > data.length)
				throw new ArrayIndexOutOfBoundsException(off + len - data.length);
			if (this.aLong5845 != -1L && this.offset >= this.aLong5845 && this.offset + len <= this.anInt5846 + this.aLong5845) {
				System.arraycopy(this.data, (int) (this.offset - this.aLong5845), data, off, len);
				this.offset += len;
				return;
			}
			long l = this.offset;
			int i_7_ = off;
			int i_8_ = len;
			if (this.offset >= this.aLong5849 && this.offset < this.aLong5849 + this.anInt5843) {
				int i_9_ = (int) (this.anInt5843 - (this.offset - this.aLong5849));
				if (i_9_ > len) {
					i_9_ = len;
				}
				System.arraycopy(this.buffer, (int) (this.offset - this.aLong5849), data, off, i_9_);
				this.offset += i_9_;
				off += i_9_;
				len -= i_9_;
			}
			if (len > this.buffer.length) {
				this.file.seek(this.offset);
				this.nextSeekOffset = this.offset;
				int lastSize;
				for (; len > 0; len -= lastSize) {
					lastSize = this.file.read(data, off, len);
					if (-1 == lastSize) {
						break;

					}
					this.nextSeekOffset += lastSize;
					this.offset += lastSize;
					off += lastSize;
				}
			} else if (len > 0) {
				nextBuffer();
				int i_11_ = len;
				if (i_11_ > this.anInt5843) {
					i_11_ = this.anInt5843;
				}
				System.arraycopy(this.buffer, 0, data, off, i_11_);
				off += i_11_;
				len -= i_11_;
				this.offset += i_11_;
			}
			if (this.aLong5845 != -1L) {
				if (this.aLong5845 > this.offset && len > 0) {
					int i_12_ = off + (int) (this.aLong5845 - this.offset);
					if (i_12_ > len + off) {
						i_12_ = len + off;
					}
					while (off < i_12_) {
						data[off++] = (byte) 0;
						len--;
						offset++;
					}
				}
				long l_13_ = -1L;
				long l_14_ = -1L;
				if (this.aLong5845 >= l && this.aLong5845 < i_8_ + l) {
					l_13_ = this.aLong5845;
				} else if (l >= this.aLong5845 && l < this.aLong5845 + this.anInt5846) {
					l_13_ = l;
				}
				if (this.aLong5845 + this.anInt5846 > l && this.anInt5846 + this.aLong5845 <= i_8_ + l) {
					l_14_ = this.anInt5846 + this.aLong5845;
				} else if (l + i_8_ > this.aLong5845 && i_8_ + l <= this.anInt5846 + this.aLong5845) {
					l_14_ = i_8_ + l;
				}
				if (l_13_ > -1L && l_14_ > l_13_) {
					int i_15_ = (int) (l_14_ - l_13_);
					System.arraycopy(this.data, (int) (l_13_ - this.aLong5845), data, i_7_ + (int) (l_13_ - l), i_15_);
					if (l_14_ > this.offset) {
						len -= l_14_ - this.offset;
						this.offset = l_14_;
					}
				}
			}
		} catch (IOException ioexception) {
			this.nextSeekOffset = -1;
			throw ioexception;
		}
		if (len > 0)
			throw new EOFException();
	}

	public void read(byte[] data) throws IOException {
		read(data, 0, data.length);

	}

	public void flush() throws IOException {
		if (-1L != this.aLong5845) {
			if (this.nextSeekOffset != this.aLong5845) {
				this.file.seek(this.aLong5845);
				this.nextSeekOffset = this.aLong5845;
			}
			this.file.write(this.data, 0, this.anInt5846);
			this.nextSeekOffset += this.anInt5846;
			if (this.nextSeekOffset > this.aLong5842) {
				this.aLong5842 = this.nextSeekOffset;
			}
			long l = -1L;
			long l_16_ = -1L;
			if (this.aLong5845 >= this.aLong5849 && this.aLong5845 < this.anInt5843 + this.aLong5849) {
				l = this.aLong5845;
			} else if (this.aLong5849 >= this.aLong5845 && this.aLong5849 < this.aLong5845 + this.anInt5846) {
				l = this.aLong5849;
			}
			if (aLong5845 + anInt5846 > this.aLong5849 && this.aLong5845 + this.anInt5846 <= anInt5843 + aLong5849) {
				l_16_ = anInt5846 + aLong5845;
			} else if (anInt5843 + aLong5849 > aLong5845 && aLong5849 + anInt5843 <= aLong5845 + anInt5846) {
				l_16_ = aLong5849 + anInt5843;
			}
			if (l > -1L && l_16_ > l) {
				int i_17_ = (int) (l_16_ - l);
				System.arraycopy(this.data, (int) (l - aLong5845), this.buffer, (int) (l - aLong5849), i_17_);
			}
			this.aLong5845 = -1;
			this.anInt5846 = 0;

		}
	}

	public void nextBuffer() throws IOException {
		this.anInt5843 = 0;
		if (offset != nextSeekOffset) {
			file.seek(offset);
			nextSeekOffset = offset;
		}
		aLong5849 = offset;
		int read;
		for (; anInt5843 < buffer.length; anInt5843 += read) {
			int numRead = this.buffer.length - anInt5843;
			if (numRead > 200000000) {
				numRead = 200000000;
			}
			read = this.file.read(this.buffer, anInt5843, numRead);
			if (read == -1) {
				break;
			}
			this.nextSeekOffset += read;
		}
	}

	public void seek(long pointer) throws IOException {
		if (pointer < 0L)
			throw new IOException("Unexpected seek pointer: negative");
		this.offset = pointer;
	}

	public void close() throws IOException {
		flush();
		file.close();
	}

	public long size() {
		return size;
	}

}
